# frozen_string_literal: true
using RubyNext;
require 'active_support/all'

module Katarina
  class Schema
    attr_reader :controller

    def initialize(path, controller, action, http_method, response_code, schema)
      @path = path
      @controller = controller
      @action = action
      @http_method = http_method
      @response_code = response_code
      @schema = schema
    end

    def types(schema = @schema)
      case; when (__m__ = schema) && false 
      when ((__p_1__ = __m__.respond_to?(:deconstruct_keys)) && (((__m_hash__ = __m__.deconstruct_keys([:type, :properties])) || true) && ((Hash === __m_hash__) || Kernel.raise(TypeError, "#deconstruct_keys must return Hash")))) && (((__p_3__ = __m_hash__.key?(:type)) && __m_hash__.key?(:properties)) && (("object" === __m_hash__[:type]) && ((properties = __m_hash__[:properties]) || true))) then build_object(properties)
      when (__m_hash__ = __m__.deconstruct_keys([:type, :items])) && ((__p_3__ && __m_hash__.key?(:items)) && (("array" === __m_hash__[:type]) && ((items = __m_hash__[:items]) || true)))       then [types(items)]
      when (__m_hash__ = __m__.deconstruct_keys([:type])) && (__p_3__ && ((type = __m_hash__[:type]) || true))                  then type; else; Kernel.raise(NoMatchingPatternError, __m__.inspect)
      end
    end

    def name
      [
        prefix,
        *Katarina::Path.include_paths(@controller.split('/')),
        action,
        response_code.to_s
      ].map(&:camelize).join
    end

    private

    attr_reader :path, :action, :http_method, :response_code

    def prefix
      Katarina.config.prefix ? 'T' : ''
    end

    def build_object(properties)
      properties.keys.each_with_object({}) { |_1, _2| _2[_1] = property_type(properties[_1]) }
    end

    def property_type(property)
      case; when (__m__ = property) && false 
      when (__p_2__ = ((__p_1__ = __m__.respond_to?(:deconstruct_keys)) && (((__m_hash__ = __m__.deconstruct_keys([:type])) || true) && ((Hash === __m_hash__) || Kernel.raise(TypeError, "#deconstruct_keys must return Hash"))))) && ((__p_3__ = __m_hash__.key?(:type)) && (((__m_hash__el__ = __m_hash__[:type]) || true) && (("object" === __m_hash__el__) || ("array" === __m_hash__el__)))) then types(property)
      when __p_2__ && (__p_3__ && ((type = __m_hash__[:type]) || true))                    then type; else; Kernel.raise(NoMatchingPatternError, __m__.inspect)
      end
    end
  end
end
